<?php
/**
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	OS Membership
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

defined( '_JEXEC' ) or die ;
//error_reporting(E_ALL);
class plgOSMembershipPlanarticles extends JPlugin
{	
	
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		JFactory::getLanguage()->load('plg_osmembership_articles', JPATH_ADMINISTRATOR);
		JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_osmembership/tables');
	}
	/**
	 * Render settings from
	 * @param PlanOSMembership $row
	 */
	function onEditSubscriptionPlan($row) {	
		ob_start();
			$this->_drawSettingForm($row);		
			$form = ob_get_contents();	
		ob_end_clean();		
		return array('title' => JText::_('PLG_OSMEMBERSHIP_PLAN_ARTICLE_SETTINGS'),							
					'form' => $form
		) ;				
	}

	/**
	 * Store setting into database
	 * @param PlanOsMembership $row
	 * @param Boolean $isNew true if create new plan, false if edit
	 */
	function onAfterSaveSubscriptionPlan($row, $data,$isNew) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$planId = $row->id;
		$articleIds = $data['article_id'];
		if (!$isNew)
		{
			$query->clear();
			$query->delete('#__osmembership_articles')->where('plan_id='.(int)$planId);
			$db->setQuery($query);
			$db->query();
		}
		if (count($articleIds))
		{
			for ($i = 0; $i < count($articleIds); $i++)
			{
				$articleId = $articleIds[$i];
				$query->clear();
				$query->insert('#__osmembership_articles')
					  ->columns('plan_id,article_id')
					  ->values("$row->id,$articleId");
				$db->setQuery($query);
				$db->query();
			}
		}
	}
	
	function getCategories($parent_id = 1, $params)
	{
		$categories = $params->get('category');
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$parentfilter = is_numeric($parent_id) ? "parent_id = ".(int)$parent_id : "";
		$query->select('*,id AS category_id, title AS category_name')
    		  ->from('#__categories')
    		  ->where('extension = "com_content"')
    		  ->where('published = 1')
    		  ->where($parentfilter)
    	;
    	if (count($categories) && !in_array(0,$categories))
    	$query->where('id IN ('.implode(',',$categories).')');
    	$db->setQuery($query);
    	return $db->loadObjectList();
	}
   /**
     * get child category
     *
     * int $id
     * @return unknown
     */
    function getChildCategory($id)
    {
    	$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('COUNT(id)')->from('#__categories')->where('parent_id='.(int)$id)->where('published=1');
    	$db->setQuery($query);
    	return $db->loadResult();
    }
	/**
	 * get chil Article
	 */
    function getChildArticle($id)
    {
    	$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('id, title AS title_article')
    		   ->from('#__content')
    		   ->where('catid='.(int)$id);
    	$db->setQuery($query);
    	return $db->loadObjectList();
    }
    
   /**
     * get total events in category
     */
    function countArticle($categoryId)
    {
    	$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('COUNT(id)')->from('#__content')->where('catid='.(int)$categoryId);
    	$db->setQuery($query);
    	return $db->loadResult();
    }
    /**
     * get old article plan
     */
    function getOldPlanArticle($planId)
    {
    	$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('article_id')->from('#__osmembership_articles')->where('plan_id='.(int)$planId);
    	$db->setQuery($query);
    	return $db->loadColumn();
    }
    /**
     * get total article plan
     */
    function totalArticlePlan($planId,$catrgoryId)
    {
    	$db = JFactory::getDbo();
    	$query = $db->getQuery(true);
    	$query->select('COUNT(a.id)')
    		  ->from('#__osmembership_articles AS a')
    		  ->innerJoin('#__content AS b ON a.article_id = b.id')
    		  ->where('a.plan_id='.(int)$planId)
    		  ->where('b.catid='.(int)$catrgoryId)
    	;
    	$db->setQuery($query);
    	return $db->loadResult();
    }
	
	/**
	 * Display form allows users to change setting for this subscription plan 
	 * @param object $row
	 * 
	 */	
	function _drawSettingForm($row) {
		$params = $this->params;
		$planId = $row->id;
		$document = JFactory::getDocument();
		$document->addStyleSheet(JUri::root().'plugins/osmembership/planarticles/assets/css/style.css');
	?>
	
	<table class="admintable adminform" style="width: 90%;">
		<tr>
			<td class="key">
						<?php echo JText::_('PLG_OSMEMBERSHIP_PLAN_ARTICLE')?>
					</td>
					<td width="70%">
						<div id="accordian">
						<?php
						if (!function_exists('buildArticle')) 
							{
								function buildArticle($parent = 1, $level = 0, $params, $currentCat = null,$planId) 
								{
									$articleIds = plgOSMembershipPlanarticles::getOldPlanArticle($planId);
									$levelStart = 0;
									$levelEnd = 0;
									if ( (!$levelEnd || $level < $levelEnd) && $rows = plgOSMembershipPlanarticles::getCategories($parent, $params) ) 
									{
										if ($level >= $levelStart) : ?>
											
											<ul class="level<?php echo $level ?> accordion" id="accordion">
												<?php endif;
												foreach( $rows as $row ) 
												{
													$articles = plgOSMembershipPlanarticles::getChildArticle($row->category_id);
													if ($level >= $levelStart) 
													{
														$totalSub = plgOSMembershipPlanarticles::getChildCategory($row->category_id);
														$countArticles = plgOSMembershipPlanarticles::countArticle($row->category_id);
														$totalArticlePlan = plgOSMembershipPlanarticles::totalArticlePlan($planId,$row->category_id);
														$countArticles == $totalArticlePlan ? $checked = 'checked="checked"' : $checked = '';
														if($totalSub)
														{
															$class = 'not-empty';
														}
														else 
														{
															$class = 'empty';
														}
														?>
														<li <?php echo ($currentCat == $row->category_id ? ' id="current"' : '') ?>>
														<a class="level<?php echo $level . ($currentCat == $row->category_id ? ' active' : '') ?>" id="<?php echo $level; ?>" target="_self">
															<?php echo htmlspecialchars(stripslashes($row->category_name), ENT_COMPAT, 'UTF-8') ?>
														</a>
														<!--  <span class="<?php echo $class; ?>"></span>-->
									                <?php
												 	}
														?>
															<?php if ($countArticles) :?>
																<div class="panel-body">
																<label class="checkbox"> <input <?php echo $checked; ?> type="checkbox" value="" id="<?php echo $row->category_id?>" class="checkAll" name=""> <b>#</b> </label> 
																<br>
																<?php endif; ?>
																<?php 
																foreach ($articles as $article)
																{
																	(in_array($article->id,$articleIds)) ? $checked = 'checked="checked"' : $checked = '';
																	?>
																	<label class="checkbox"> <input type="checkbox" <?php echo $checked;?> value="<?php echo $article->id; ?>" id="article_<?php echo $article->id; ?>" name="article_id[]" class="checkall_<?php echo $row->category_id?>">
																		<?php echo $article->title_article; ?>
																	</label> <br>
																	<?php
																}
															buildArticle($row->category_id, $level + 1, $params, $currentCat,$planId);
															if ($level >= $levelStart) : ?>
															</div>
															
									                    </li>
									                <?php
									                endif;
												} // end foreach
												if ($level >= $levelStart) : ?>
								            </ul>
										<?php
							            endif;
									}
								}
							}
							
							buildArticle(1, 0, $params,null,$planId); 
						?>
						</div>
					</td>
		</tr>
	</table>
	<script type="text/javascript">
		(function($){
			$(document).ready(function(){
				$("#accordion > li a").click(function(){
					if(false == $(this).next().is(':visible')) {
						$('#accordion > ul').slideUp(300);
					}
					$(this).next().slideToggle(300);
				});
				$('#accordion > li .panel-body').not(':first').hide();
				
			    $(".checkAll").click(function () {
			    	var ID = $(this).attr("id");
			    	var numberOfChecked = $(".checkall_"+ID+":checkbox:checked").length;
			    	var totalCheckboxes = $('.checkall_'+ID).length;
			    	if(numberOfChecked > totalCheckboxes)
			    	{
			    		$('.checkall_' + ID).attr("checked", false);
				    }
			    	else
			    	{
				        if ($(".checkAll").is(':checked')) {
				            $('.checkall_' + ID).attr("checked", true);
				        } else {
				            $('.checkall_' + ID).attr("checked", false);
				        }
			    	}
			    });

			})
		})(jQuery)
		
		
	</script>
<?php							
	}
}	